<template>
  <div class="edit-popup">
    <popup
        ref="popupRef"
        :title="popupTitle"
        :async="true"
        width="550px"
        @confirm="handleSubmit"
        @close="handleClose"
    >
      <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
        <el-form-item label="RFID" prop="rfid">
          <el-input v-model="formData.rfid" clearable placeholder="请输入" />
        </el-form-item>
        <el-form-item label="所属栏舍" prop="fence_house_id">
          <el-select
              v-model="formData.fence_house_id"
              clearable
              remote
              filterable
              placeholder="请选择"
              :remote-method="queryFenceHouse"
              :loading="loading"
          >
            <el-option
                v-for="(item, index) in optionsData.fenceHouse"
                :key="index"
                :label="item.fencehouseinfo"
                :value="item.id"
            />
          </el-select>
        </el-form-item>

      </el-form>
    </popup>
  </div>
</template>

<script lang="ts" setup name="animalRfidEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiAnimalRfidAdd, apiAnimalRfidEdit, apiAnimalRfidDetail } from '@/api/animal_rfid'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
import {apiFenceHouseLists} from "@/api/monitor_threshold";
import {useDictOptions} from "@/hooks/useDictOptions";
import {apiLandLists, getUserList} from "@/api/product";
import {ref} from "vue";
defineProps({
  dictData: {
    type: Object as PropType<Record<string, any[]>>,
    default: () => ({})
  }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
  return mode.value == 'edit' ? '编辑档案RFID' : '新增档案RFID'
})

// 表单数据
const formData = reactive({
  id: '',
  rfid: '',
  fence_house_id: '',

})


// 表单验证
const formRules = reactive<any>({
  rfid: [{
    required: true,
    message: '请输入',
    trigger: ['blur']
  }],
})
const { optionsData } = useDictOptions<{
  fenceHouse: any[]
}>({
  fenceHouse: {
    api: apiFenceHouseLists
  }
})

const loading = ref(false)

const queryFenceHouse = async (fence_house_name: string) => {
  loading.value = true
  const fenceHouseList = await apiFenceHouseLists({
    fence_house_name: fence_house_name ?? ''
  })
  optionsData.fenceHouse = fenceHouseList
  loading.value = false
}



// 获取详情
const setFormData = async (data: Record<any, any>) => {
  for (const key in formData) {
    if (data[key] != null && data[key] != undefined) {
      //@ts-ignore
      formData[key] = data[key]
    }
  }


}

const getDetail = async (row: Record<string, any>) => {
  const data = await apiAnimalRfidDetail({
    id: row.id
  })
  setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
  await formRef.value?.validate()
  const data = { ...formData,  }
  mode.value == 'edit'
      ? await apiAnimalRfidEdit(data)
      : await apiAnimalRfidAdd(data)
  popupRef.value?.close()
  emit('success')
}

//打开弹窗
const open = (type = 'add') => {
  mode.value = type
  popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
  emit('close')
}



defineExpose({
  open,
  setFormData,
  getDetail
})
</script>
